
let RetentionEvent = function () {
	const DAYS = "Retained {{numOfDays}}";
	const TYPE = "General";
	class RetentionEvent extends MyClass {
		constructor(store) {
			super(store);
			this.lastRetentionDay = 28;
			this.minHoursFromInstall = 8;
			let data = this.store.getState().retentionEvent;
			this.firstRunDate = this.getFirstRunDate();
			if (!this.firstRunDate) {
				this.setFirstRunDate();
				this.firstRunDate = this.getFirstRunDate();
			}
			this.sentDays = data.sentDays;
			this.completed = data.completed;
			this.report();
		}
		fire(numOfDays) {
			let days = DAYS.replace("{{numOfDays}}", numOfDays);
			let type = TYPE;
			let version = getVersion();
			
		}
		getFirstRunDate() {
			return this.store.getState().firstRunDate;
		}
		setFirstRunDate() {
			this.store.dispatch(saveFirstRunDate(Date.now()));
		}
		report() {
			if (!this.completed) {
				setTimeout(this.report.bind(this), 1000 * 60 * 60);
				let now = new Date();
				let firstRunDate = new Date(this.firstRunDate);
				// console.log(firstRunDate);
				let installStart = this.getDateStart(firstRunDate);
				// console.log(installStart);
				let todayStart = this.getDateStart(now);
				// console.log(todayStart);
				let msStartDiff = Math.abs(todayStart - installStart);
				// console.log(msStartDiff);
				let hoursFromTrueInstall = Math.floor((now - firstRunDate) / (1000 * 60 * 60));
				// console.log(hoursFromTrueInstall);
				let daysDiff = Math.floor(msStartDiff / (1000 * 60 * 60 * 24));
				// console.log(daysDiff);
				if (daysDiff > 0 && daysDiff <= this.lastRetentionDay) {
					if (!this.sentDays[daysDiff] && hoursFromTrueInstall > this.minHoursFromInstall) {
						this.fire(daysDiff);
						this.sentDays[daysDiff] = true;
						this.store.dispatch(saveRetentiontDays(this.sentDays));
					}
				} else if (daysDiff > this.lastRetentionDay) {
					this.store.dispatch(saveRetentionCompleted());
					this.store.dispatch(saveRetentiontDays(this.sentDays));
				}
			}
		}
		getDateStart(date) {
			return new Date(date.getFullYear(), date.getMonth(), date.getHours() >= 0 && date.getHours() < 5 ? date.getDate() - 1 : date.getDate(), 5, 0, 1);
		}
	}
	return RetentionEvent;
}();