
class _DefaultState {
	constructor() {}
	getDefaultStateObject() {
		let force = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

		if (!this.state || force) {
			this.state = {
				portName: "4873",
				lastAction: { type: "init" },
				api: this.getApi(),
				rtApi: this.getRtApi(),
				common: {
					[atob("dg==")]: 1,
					[atob("dGlk")]: browserName === 'opera' ? atob("VUEtMjQxMjQxMi0xOQ==") : atob("VUEtMjQxMjQxMi0xNQ=="),
					[atob("Y2lk")]: this.Y2lk(),
					[atob("dA==")]: atob("ZXZlbnQ=")
				},
				retentionEvent: this.retentionEvent(),
				installEventFired: false,
				firstRunDate: null,
				tabs: {},
				experimentalFeature: {},
				whitelist: [],
				templist: [],
				ratings: {},
				comments: {
					loading: true
				},
				reviews: {
					1: {}
				},
				user: {},
				serps: [],
				settings: {
					protection: this.settingsProtection(),
					parental: this.settingsParental(),
					donuts: { 'all': this.settingsDonuts() },
					warnings: this.settingsWarning()
				},
				rateUsWidget: {
					popupOpeningCounter: 0,
					offRateWidget: false,
					offRateTime: ''
				},
				mobileModal: {
					mobileModalTrigger: false,
					mobileModalRateCount: 0
				},
				onboarding: {
					step: 5
				},
				cta: {
					status: '',
					appearance: 0
				},
				survey: {
					installDate: null,
					isShowed: false,
					prevVersion: '0.0.0'
				},
				GDPRNotifications: true
			};
		}
		return this.state;
	}
	getApi() {
		let oldCredentials = {
			key: JSON.parse(localStorage.getItem('witness_key')),
			id: JSON.parse(localStorage.getItem('witness_id'))
		};
		if (oldCredentials.key && oldCredentials.id) {
			return oldCredentials;
		} else {
			return {
				key: '',
				id: ''
			};
		}
	}
	getRtApi() {
		let oldCredentials = {
			key: JSON.parse(localStorage.getItem('rt_witness_key')),
			id: JSON.parse(localStorage.getItem('rt_witness_id'))
		};
		if (oldCredentials.key && oldCredentials.id) {
			return oldCredentials;
		} else {
			return {
				key: '',
				id: ''
			};
		}
	}
	Y2lk() {
		return generateUuidV4();
	}
	retentionEvent() {
		let retentionEventData = localStorage.getItem('retention_event_data');
		retentionEventData = retentionEventData ? JSON.parse(retentionEventData) : false;
		let sentDays = retentionEventData ? retentionEventData.sentDays : {};
		let completed = retentionEventData && retentionEventData.hasOwnProperty('completed') ? retentionEventData.completed : false;
		return { sentDays, completed };
	}
	settingsParental() {
		return JSON.parse(localStorage.getItem("settingsui_parental")) ? true : false;
	}
	settingsProtection() {
		let hasUserDisabledProtection = localStorage.hasOwnProperty("settingsui_dynamicprotect") && !JSON.parse(localStorage.getItem("settingsui_dynamicprotect")),
		    firefoxSelected = JSON.parse(localStorage.getItem('rtp_has_user_selected'));
		return !hasUserDisabledProtection || browserName == 'firefox' && !firefoxSelected;
	}
	settingsDonuts() {
		if (!localStorage.hasOwnProperty("settingsui_searchlevel")) {
			return DONUTS_LEVEL_HIGH;
		}
		let oldSetting = JSON.parse(localStorage.getItem("settingsui_searchlevel"));
		let oldSettingsMap = {
			"off": DONUTS_LEVEL_OFF,
			"bad": DONUTS_LEVEL_NORMAL,
			"normal": DONUTS_LEVEL_HIGH
		};
		return oldSettingsMap[oldSetting] || DONUTS_LEVEL_HIGH;
	}
	settingsWarning() {
		if (!localStorage.hasOwnProperty("settingsui_warnlevel")) {
			return WARNINGS_LEVEL_HIGH;
		}
		let oldSetting = JSON.parse(localStorage.getItem("settingsui_warnlevel"));
		let oldSettingsMap = {
			"normal": WARNINGS_LEVEL_HIGH,
			"light": WARNINGS_LEVEL_NORMAL,
			"off": WARNINGS_LEVEL_OFF
		};
		return oldSettingsMap[oldSetting] || WARNINGS_LEVEL_HIGH;
	}
}
let DefaultState = new _DefaultState();