
class ButtonAction extends React.Component {
	rateSite() {
		let scroll = document.querySelector('.rating-flow-scroll');
		if (scroll) {
			scroll.scrollTo ? scroll.scrollTo(0, 0) : scroll.contentWindow && scroll.contentWindow.scrollTo(0, 0);
		}
		this.props.dispatch(toNextStep(this.props.host, this.props.userId));
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: this.props.commonComponent,
				[atob("ZWE=")]: this.props.commonType,
				[atob("ZWw=")]: this.props.host
			}
		});
	}
	rateFlow() {
		if (this.props.typeAction === 'RatingFlow') {
			webextApi.runtime.sendMessage({
				name: SEND_MESSAGE, params: {
					[atob("ZWM=")]: this.props.commonComponent,
					[atob("ZWE=")]: "Step 1 Submit",
					[atob("ZWw=")]: this.props.text
				}
			});
			this.props.dispatch(rateSafety(this.props.host, this.props.text === webextApi.i18n.getMessage('yes')));
			this.props.dispatch(this.props.text === webextApi.i18n.getMessage('yes') ? overNextStep(this.props.host, this.props.userId) : toNextStep(this.props.host, this.props.userId));
		} else {
			webextApi.runtime.sendMessage({
				name: SEND_MESSAGE, params: {
					[atob("ZWM=")]: this.props.commonComponent,
					[atob("ZWE=")]: "Step 3 Submit",
					[atob("ZWw=")]: this.props.text
				}
			});
			this.props.dispatch(rateChildSafety(this.props.host, this.props.text === webextApi.i18n.getMessage('yes'), this.props.userId));
			this.props.dispatch(this.props.text === webextApi.i18n.getMessage('yes') ? overNextStep(this.props.host, this.props.userId) : toNextStep(this.props.host, this.props.userId));
		}
	}
	goToSite(e) {
		this.props.dispatch(document.getElementById('warn-checkbox') && document.getElementById('warn-checkbox').checked ? addToWhitelist(this.props.host) : addToTemplist(this.props.host));
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: this.props.commonComponent,
				[atob("ZWE=")]: this.props.commonType + " Go To Site",
				[atob("ZWw=")]: this.props.host
			}
		});
		if (document.getElementById('warn-checkbox') && document.getElementById('warn-checkbox').checked) {
			webextApi.runtime.sendMessage({
				name: SEND_MESSAGE, params: {
					[atob("ZWM=")]: this.props.commonComponent,
					[atob("ZWE=")]: this.props.commonType + " Don't Warn",
					[atob("ZWw=")]: this.props.host
				}
			});
		}
		document.getElementById('warning-container').remove();
	}
	getOut(e) {
		document.getElementById('warn-checkbox') && document.getElementById('warn-checkbox').checked && this.props.dispatch(addToWhitelist(this.props.host));
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: this.props.commonComponent,
				[atob("ZWE=")]: this.props.commonType + " Back",
				[atob("ZWw=")]: this.props.host
			}
		});
		window.onbeforeunload = e => {
			this.startToUnload = true;
		};
		history.back();
		setTimeout(() => {
			!this.startToUnload && webextApi.runtime.sendMessage({ name: CLOSE_TAB_MESSAGE });
		}, 100);
	}
	render() {
		var _props = this.props;
		let typeAction = _props.typeAction,
		    text = _props.text,
		    dispatch = _props.dispatch;

		if (typeAction === 'goToSite') {
			return React.createElement(
				"div",
				{ className: "action-button action-button_white", onClick: this.goToSite.bind(this) },
				React.createElement(
					"span",
					null,
					webextApi.i18n.getMessage('goToSite')
				)
			);
		}
		if (typeAction === 'getOut') {
			return React.createElement(
				"div",
				{ className: "action-button action-button_green", onClick: this.getOut.bind(this) },
				React.createElement(
					"span",
					null,
					webextApi.i18n.getMessage('outOfHere')
				)
			);
		}
		if (typeAction === 'Rate') {
			return React.createElement(
				"div",
				{ className: "action-button action-button_popup", onClick: this.rateSite.bind(this) },
				webextApi.i18n.getMessage('rateThisSite')
			);
		}
		if (typeAction === 'RatingFlow' || typeAction === 'RatingFlowChild') {
			return React.createElement(
				"div",
				{ className: text === webextApi.i18n.getMessage('yes') ? "action-button action-button_rating-flow action-button_green" : "action-button action-button_rating-flow action-button_red", onClick: this.rateFlow.bind(this) },
				text
			);
		}
		return React.createElement("i", null);
	}
}