
class WarningReportsContainer extends React.Component {
	onFullReportClick() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "WarningScreen",
				[atob("ZWE=")]: (this.props.parent ? "Parental" : "Severe") + " View Full Report",
				[atob("ZWw=")]: this.props.host
			}
		});
	}
	render() {
		var _props = this.props;
		let categories = _props.categories,
		    parent = _props.parent,
		    isInPopup = _props.isInPopup,
		    host = _props.host;

		return React.createElement(
			"div",
			{ className: "warning-reports-container" },
			!parent && categories.map(function (item) {
				if (_.indexOf(isInPopup ? CATEGORIES_RULES.popup : CATEGORIES_RULES.warnings, +item.id) !== -1) {
					let classNameReport = 'warning-reports-container__label ' + ' warning-reports-container__label_' + item.color;
					return React.createElement(
						"div",
						{ className: classNameReport },
						webextApi.i18n.getMessage(item.description)
					);
				}
			}),
			!isInPopup && React.createElement(
				"div",
				{ className: "warning-reports-container__all-btn" },
				React.createElement(
					"a",
					{
						target: "_blank",
						onClick: this.onFullReportClick.bind(this),
						href: FULL_REPORT_URL + host + WARNING_REDIRECT_PARAMETERS },
					webextApi.i18n.getMessage('viewFullReport')
				)
			)
		);
	}
}