
class DonutTooltip extends React.Component {
	constructor(props) {
		super(props);
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Onboarding",
				[atob("ZWE=")]: this.props.onboarding.step + " Step Show",
				[atob("ZWw=")]: WotApi.getEncodedDomain(location.href)
			}
		});
		window.onunload = () => {
			this.props.onboarding.step < 3 && this.props.dispatch(toNextStepOnboarding(0));
		};
	}
	clickOnTooltipBtn() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Onboarding",
				[atob("ZWE=")]: this.props.onboarding.step + " Step Click",
				[atob("ZWw=")]: WotApi.getEncodedDomain(location.href)
			}
		});
		this.props.dispatch(toNextStepOnboarding());
		this.props.onboarding.step++;
		this.forceUpdate();
	}
	getSpanDonutColor() {
		const defaultColor = 'invizible';
		const onboardingTooltip = document.querySelector('.donut-tooltip.donut-tooltip_0');
		if (!onboardingTooltip) return defaultColor;
		const onboardRect = onboardingTooltip.getBoundingClientRect();
		const allDonuts = [].slice.call(document.querySelectorAll('.donut-container .donut'));
		const nearestDonut = allDonuts.filter(donut => {
			const donutRect = donut.getBoundingClientRect();
			const diffX = Math.abs(onboardRect.x - donutRect.x);
			const diffY = Math.abs(onboardRect.y - donutRect.y);
			return diffX < 30 && diffY < 30;
		})[0];
		if (!nearestDonut) return defaultColor;
		const color = nearestDonut.className.match(/donut_(.+)/)[1];
		return color || defaultColor;
	}
	render() {
		var _props = this.props;
		const onboarding = _props.onboarding,
		      childSafety = _props.childSafety;

		if (onboarding.step >= 3) {
			window.location.reload();
			return React.createElement("i", null);
		}
		let classNameTooltip = "donut-tooltip donut-tooltip_" + onboarding.step,
		    textTooltip = '',
		    top = 0;
		switch (onboarding.step) {
			case 1:
				textTooltip = { __html: "<span>" + webextApi.i18n.getMessage("thisPopupShows") + "</span>" };
				top = childSafety === NOT_SAFE ? 256 : 230;
				break;
			case 2:
				textTooltip = { __html: "<span>" + webextApi.i18n.getMessage("clickOnTheGearIcon").replace('%GEARICON%', "</span><div class='wot-gear-icon'></div><span>") + "</span>" };
				top = -51;
				break;
			default:
				textTooltip = { __html: "<span>" + webextApi.i18n.getMessage("hoverOverTheWOT").replace(' %DONUTICON%', "</span> <div class='wot-donut-icon'></div><span>") + "</span>" };
				top = 0;
		}
		setTimeout(() => {
			const donutTooltipIcon = document.querySelector('.donut-tooltip .wot-donut-icon');
			if (donutTooltipIcon) {
				donutTooltipIcon.className += ' ' + this.getSpanDonutColor();
			}
		}, 10);
		return React.createElement(
			"div",
			{ className: classNameTooltip,
				style: { top: top + 'px' } },
			React.createElement("div", { dangerouslySetInnerHTML: textTooltip }),
			onboarding.step === 1 && React.createElement(
				"span",
				{ className: "donut-tooltip__btn",
					onClick: this.clickOnTooltipBtn.bind(this) },
				webextApi.i18n.getMessage("okGotIt")
			),
			onboarding.step === 2 && React.createElement(
				"span",
				{ className: "donut-tooltip__btn",
					onClick: this.clickOnTooltipBtn.bind(this) },
				webextApi.i18n.getMessage("coolGotIt")
			)
		);
	}
}