
class RadioButtonContainer extends React.Component {
    render() {
        var _props = this.props;
        const dispatch = _props.dispatch,
              settings = _props.settings,
              type = _props.type,
              actions = _props.actions,
              id = _props.id,
              donutState = _props.donutState,
              host = _props.host;

        return React.createElement(
            'div',
            { className: 'options-tab' },
            (!id && type === 'warnings' || id === 'all') && React.createElement(
                'div',
                { className: 'options-tab__header-radio-button' },
                actions.map(item => {
                    return React.createElement(
                        'div',
                        { className: 'options-tab__header-radio-button__text' },
                        item.title
                    );
                })
            ),
            (donutState || type === 'warnings' || id === 'all') && React.createElement(
                'div',
                { className: 'options-tab__container-radio-button' },
                actions.map(item => {
                    let settingsType = settings[type][id] ? settings[type][id] : settings[type].all;
                    type === 'warnings' && (settingsType = settings[type]);
                    return React.createElement(
                        'div',
                        { className: 'options-tab__container-radio-button__item' },
                        React.createElement(Tooltip, { className: 'options-tooltip', text: webextApi.i18n.getMessage(item.arguments),
                            onClick: () => {
                                if (settings.protection) {
                                    dispatch(item.action(item.arguments, id));
                                    webextApi.runtime.sendMessage({
                                        name: SEND_MESSAGE,
                                        params: host ? _.merge({}, item.params, { [atob("ZWE=")]: "Donuts " + host }) : item.params
                                    });
                                }
                            } }),
                        React.createElement('input', { name: id ? id : type, type: 'radio', checked: settingsType === item.arguments ? true : false }),
                        React.createElement('label', { className: 'options-tab__container-radio-button__item__label' })
                    );
                })
            )
        );
    }
}