
class WhiteList extends React.Component {
    addToWhitelist(e) {
        e.preventDefault();
        let host,
            site = document.getElementById('wl_site').value.trim();
        if (site && site.indexOf('.') !== -1 && site.indexOf("@") === -1) {
            if (!SUPPORTED_PROTOCOLS.exec(site) && site.indexOf('http') !== 0) {
                site = 'http://' + site;
            }
            if (SUPPORTED_PROTOCOLS.exec(site) && VALID_URL_WITHOUT_PROTOCOL.test(site)) {
                host = WotApi.getEncodedDomain(site);
                if (host) {
                    this.props.dispatch(addToWhitelist(host));
                    document.getElementById('wl_site').value = '';
                    return true;
                }
            }
        }
        document.getElementById('wl_site').style.border = "solid 1px #ef4035";
        document.getElementById('wl_site').style.color = "#ef4035";
        return false;
    }
    onFocus() {
        document.getElementById('wl_site').style.border = "solid 1px #6cb720";
        document.getElementById('wl_site').style.color = "black";
    }
    onBlur() {
        document.getElementById('wl_site').style.border = "solid 1px #d8d8d8";
        document.getElementById('wl_site').style.color = "black";
    }
    onInputChange() {
        document.getElementById('wl_site').style.border = "solid 1px #6cb720";
        document.getElementById('wl_site').style.color = "black";
    }
    render() {
        var _props = this.props;
        const whitelist = _props.whitelist,
              dispatch = _props.dispatch,
              settings = _props.settings;

        return React.createElement(
            'div',
            { className: 'options__container__whitelist' },
            React.createElement(
                'div',
                { className: 'options__container__whitelist__header' },
                webextApi.i18n.getMessage('whitelistTitle')
            ),
            React.createElement(
                'form',
                null,
                React.createElement('input', { type: 'text', id: 'wl_site', onBlur: this.onBlur.bind(this), onFocus: this.onFocus.bind(this), onChange: this.onInputChange.bind(this), placeholder: webextApi.i18n.getMessage('whitelistPlaceholder') }),
                React.createElement(
                    'button',
                    { id: 'wl_add', onClick: this.addToWhitelist.bind(this) },
                    webextApi.i18n.getMessage('add')
                )
            ),
            whitelist.length != 0 ? whitelist.map(function (item) {
                let whiteListItemStyle = {
                    backgroundImage: 'url(http://www.google.com/s2/favicons?domain=' + item + ')'
                };
                return React.createElement(
                    'div',
                    { className: 'options__container__whitelist__item' },
                    React.createElement('div', { className: 'options__container__whitelist__item__icon', style: whiteListItemStyle }),
                    React.createElement(
                        'span',
                        null,
                        item
                    ),
                    React.createElement(
                        'div',
                        { className: 'options__container__whitelist__item__close',
                            onClick: () => {
                                webextApi.runtime.sendMessage({
                                    name: SEND_MESSAGE, params: {
                                        [atob("ZWM=")]: "Settings",
                                        [atob("ZWE=")]: "Delete Site from Whitelist",
                                        [atob("ZWw=")]: item
                                    }
                                });
                                settings.protection && dispatch(removeFromWhitelist(item));
                            } },
                        '\u2716'
                    )
                );
            }) : React.createElement(
                'div',
                { className: 'options__container__whitelist__empty' },
                React.createElement(
                    'span',
                    null,
                    webextApi.i18n.getMessage('empty')
                )
            )
        );
    }
}