
//COMPONENTS
class MenuButton extends React.Component {
    constructor(props) {
        super(props);
        this.state = { isMenuOpen: false };
    }
    openMenu(e) {
        if (e.target.className.indexOf('drop') !== -1) {
            webextApi.runtime.sendMessage({
                name: SEND_MESSAGE, params: {
                    [atob("ZWM=")]: "Main Window",
                    [atob("ZWE=")]: "Menu",
                    [atob("ZWw=")]: "Open"
                }
            });
        }
        document.getElementById('popup-menu-container').style.transform = 'scale(1)';
    }
    componentDidMount() {
        document.body.addEventListener('click', this.closeMenu.bind(this));
    }
    componentWillUnmount() {
        document.body.removeEventListener('click', this.closeMenu.bind(this));
    }
    closeMenu() {
        document.getElementById('popup-menu-container').style.transform = 'scale(0)';
        // repaint for firefox 59 render glitch after closing
        setTimeout(firefoxRepaint, 200);
    }
    render() {
        return React.createElement(
            "div",
            { id: "popup-menu" },
            React.createElement(
                "div",
                { className: "popup-container__header__menu-btn drop", onClick: this.openMenu.bind(this) },
                React.createElement("span", { className: "popup-container__header__menu-btn__dot" }),
                React.createElement("span", { className: "popup-container__header__menu-btn__dot" }),
                React.createElement("span", { className: "popup-container__header__menu-btn__dot" })
            ),
            React.createElement(MenuContainer, {
                host: this.props.host,
                user: Object.keys(this.props.store.getState().user).length ? this.props.store.getState().user : false,
                store: this.props.store,
                showModal: this.props.showModal,
                closeMenu: this.closeMenu
            })
        );
    }
}