
class MenuContainer extends React.Component {
	showModal(type) {
		return () => {
			webextApi.runtime.sendMessage({
				name: SEND_MESSAGE, params: {
					[atob("ZWM=")]: "Main Window",
					[atob("ZWE=")]: "Menu",
					[atob("ZWw=")]: "Log In"
				}
			});
			this.props.showModal(type)();
			this.props.closeMenu();
		};
	}
	goToMyAccount() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "My Profile"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: USER_URL + MAIN_WINDOW_REDIRECT_PARAMETERS });
		window.close();
	}
	goToForum() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Forum"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: FORUM_URL + MAIN_WINDOW_REDIRECT_PARAMETERS });
		window.close();
	}
	goToTour() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Tour"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: WELCOME_URL + '/' + MAIN_WINDOW_REDIRECT_PARAMETERS });
		window.close();
	}
	goToOwn() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Claim site"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: OWN_URL + this.props.host + MAIN_WINDOW_REDIRECT_PARAMETERS });
		window.close();
	}
	goToSettings() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Settings"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: OPTIONS_URL });
		window.close();
	}
	goToDownload() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Download Classic WOT"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: DOWNLOAD_URL });
		window.close();
	}
	goToMobile() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Download Mobile"
			}
		});
		webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: MOBILE_APP_URL });
		window.close();
	}
	goToSharePage() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Share WOT"
			}
		});
		this.showModal('sharing')();
	}
	logout() {
		webextApi.runtime.sendMessage({
			name: SEND_MESSAGE, params: {
				[atob("ZWM=")]: "Main Window",
				[atob("ZWE=")]: "Menu",
				[atob("ZWw=")]: "Log Out"
			}
		});
		this.props.store.dispatch(logout());
	}
	render() {
		return React.createElement(
			"div",
			{ id: "popup-menu-container" },
			this.props.user && React.createElement(UserInfo, { userdata: this.props.user, goToMyAccount: this.goToMyAccount.bind(this) }),
			React.createElement(
				"ul",
				{ className: "popup__menu" },
				!this.props.user && React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.showModal('login'), name: "LogIn" },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__profile" }),
					webextApi.i18n.getMessage("logIn")
				),
				React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToForum.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__forum" }),
					webextApi.i18n.getMessage("forum")
				),
				React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToTour.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__tour" }),
					webextApi.i18n.getMessage("tour")
				),
				React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToSettings.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__settings" }),
					webextApi.i18n.getMessage("settings")
				),
				React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToOwn.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__own" }),
					webextApi.i18n.getMessage("ownThisSite")
				),
				browserName !== 'firefox' && React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToDownload.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__classic" }),
					webextApi.i18n.getMessage("downloadClassicWot")
				),
				React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToMobile.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__mobile" }),
					webextApi.i18n.getMessage("downloadMobileWot")
				),
				React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.goToSharePage.bind(this), name: "sharing" },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__share" }),
					webextApi.i18n.getMessage("shareWotFriends")
				),
				this.props.user && React.createElement(
					"li",
					{ className: "popup__menu-item", onClick: this.logout.bind(this) },
					React.createElement("div", { className: "popup__menu-picture popup-container__header__menu-btn__logout" }),
					webextApi.i18n.getMessage("logOut")
				)
			)
		);
	}
}