var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

class ModalMessageLogIn extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            type: props.type,
            isPassShown: false
        };
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: this.state.type === 'LogIn' ? "Opened Log In" : 'Opened Sign Up',
                [atob("ZWw=")]: "Rating Flow/Menu"
            }
        });
    }
    changeFormType(type) {
        return () => {
            if (type === 'Forgot') {
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Login/Sign Up",
                        [atob("ZWE=")]: "Forgot Link Click",
                        [atob("ZWw=")]: ""
                    }
                });
            } else {
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Login/Sign Up",
                        [atob("ZWE=")]: "Switched " + type,
                        [atob("ZWw=")]: ""
                    }
                });
            }
            this.setState({
                type
            });
            this.props.closeError();
        };
    }
    backAfterForgot() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: "Forgot Go Back",
                [atob("ZWw=")]: ""
            }
        });
        this.changeFormType('LogIn')();
    }
    openTerms() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: "Terms",
                [atob("ZWw=")]: ""
            }
        });
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: TERMS + MAIN_WINDOW_REDIRECT_PARAMETERS });
        window.close();
    }
    openPrivacyPolicy() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: "Privacy Policy",
                [atob("ZWw=")]: ""
            }
        });
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: PRIVACY_POLICY + MAIN_WINDOW_REDIRECT_PARAMETERS });
        window.close();
    }
    showPassword() {
        this.setState({
            isPassShown: true
        });
    }
    hidePassword() {
        this.setState({
            isPassShown: false
        });
    }
    readUsernameAndPassword() {
        this.props.showLoader(true);
        this.unsubscribeLogin = this.props.store.subscribe(() => {
            if (this.props.store.getState().lastAction.type === ERROR_USER_AUTH) {
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Login/Sign Up",
                        [atob("ZWE=")]: (this.state.type === "Forgot " ? "Forgot" : "") + this.state.type + " Fail",
                        [atob("ZWw=")]: ""
                    }
                });
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Login/Sign Up",
                        [atob("ZWE=")]: this.state.type + " Fail Error",
                        [atob("ZWw=")]: this.props.store.getState().lastAction.data.message
                    }
                });
                this.props.showLoader(false);
                this.props.showError();
                this.unsubscribeLogin();
            } else if (this.props.store.getState().lastAction.type === SAVE_USER_DATA) {
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Login/Sign Up",
                        [atob("ZWE=")]: this.state.type + " Success",
                        [atob("ZWw=")]: ""
                    }
                });
                this.props.showLoader(false);
                this.props.onClose();
                this.unsubscribeLogin();
            } else if (this.props.store.getState().lastAction.type === MESSAGE_USER_AUTH) {
                webextApi.runtime.sendMessage({
                    name: SEND_MESSAGE, params: {
                        [atob("ZWM=")]: "Login/Sign Up",
                        [atob("ZWE=")]: "Forgot Submit Success",
                        [atob("ZWw=")]: ""
                    }
                });
                this.props.showLoader(false);
                this.props.showMessage(webextApi.i18n.getMessage("successRecPass"));
                this.unsubscribeLogin();
            }
        });
        if (this.state.type === "Forgot") {
            return document.getElementById('modal-message__input_login').value;
        } else {
            let username = document.getElementById('modal-message__input_login').value;
            let password = document.getElementById('modal-message__input_password').value;
            return [username, password];
        }
    }
    onLoginClick() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: "Log In Click",
                [atob("ZWw=")]: ""
            }
        });
        if (document.getElementsByClassName('modal-message__input')[0].value.length === 0 || document.getElementsByClassName('modal-message__input')[1].value.length === 0) {
            this.props.showError('Error4003');
            return;
        }

        var _readUsernameAndPassw = this.readUsernameAndPassword(),
            _readUsernameAndPassw2 = _slicedToArray(_readUsernameAndPassw, 2);

        let username = _readUsernameAndPassw2[0],
            password = _readUsernameAndPassw2[1];

        this.props.store.dispatch(login(username, password));
    }
    onSignUpClick() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: "Sign Up Click",
                [atob("ZWw=")]: ""
            }
        });

        var _readUsernameAndPassw3 = this.readUsernameAndPassword(),
            _readUsernameAndPassw4 = _slicedToArray(_readUsernameAndPassw3, 2);

        let username = _readUsernameAndPassw4[0],
            password = _readUsernameAndPassw4[1];

        let name = username.split('@')[0];
        this.props.store.dispatch(register(name, username, password, password));
    }
    onGetPasswordClick() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: "Forgot Submit Click",
                [atob("ZWw=")]: ""
            }
        });
        let email = document.getElementsByClassName('modal-message__input')[0];
        console.log(email);
        if (!email || email.value.length === 0) {
            return this.props.showError('Error4003');
        }
        if (EMAIL_TO_FORWARD.test(email.value)) {
            return this.props.store.dispatch(forgot(this.readUsernameAndPassword()));
        } else {
            return this.props.showError('Error400');
        }
    }
    setInFilledState(e) {
        if (e.target.value !== '') {
            document.getElementById(e.target.id).classList.add('modal-message__input_filled');
        } else {
            document.getElementById(e.target.id).classList.remove('modal-message__input_filled');
        }
    }
    socialLogin(network) {
        return () => {
            this.props.store.dispatch(clearComments(this.props.host));
            window.open(WotAuthApi.socialLoginUrl(network), '_blank', 'width=800,height=600');
            window.close();
        };
    }
    onLogoClick() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Main Window",
                [atob("ZWE=")]: "WOT Logo",
                [atob("ZWw=")]: ""
            }
        });
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: MAIN_PAGE_URL + MAIN_WINDOW_REDIRECT_PARAMETERS });
        window.close();
    }
    onCloseClick() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Login/Sign Up",
                [atob("ZWE=")]: this.state.type + " Close",
                [atob("ZWw=")]: ""
            }
        });
        this.props.onClose();
    }
    onKeyPressed(e) {
        let event = _.merge({}, e);
        if (event.which === 13) {
            let button = document.querySelector('.modal-message__login-btn');
            button && button.click();
        }
    }
    render() {
        return React.createElement(
            "div",
            { className: "modal-message_login" },
            React.createElement(
                "div",
                { className: "modal-message__close", onClick: this.onCloseClick.bind(this) },
                React.createElement("span", { className: "modal-message__close-hover" }),
                React.createElement("span", { className: "modal-message__close-image" })
            ),
            React.createElement("div", { className: "modal-message__logo", onClick: this.onLogoClick.bind(this) }),
            React.createElement(
                "div",
                { className: "modal-message__header modal-message__header_login" },
                webextApi.i18n.getMessage(this.state.type + "Below")
            ),
            React.createElement(
                "div",
                { className: "form-wrapper" },
                React.createElement(
                    "div",
                    { className: this.state.type === 'Forgot' ? "form-wrapper__inner form-wrapper__inner_forgot" : "form-wrapper__inner" },
                    React.createElement("input", {
                        onKeyDown: this.onKeyPressed,
                        onFocus: this.props.closeError,
                        onBlur: this.setInFilledState.bind(this),
                        tabIndex: "1",
                        className: this.props.errorStatus && !(this.props.store.getState().lastAction.type === MESSAGE_USER_AUTH) ? "modal-message__input modal-message__input_error" : "modal-message__input",
                        id: "modal-message__input_login",
                        placeholder: webextApi.i18n.getMessage(this.state.type === 'Forgot' ? "SignUpUsernameInput" : this.state.type + "UsernameInput")
                    }),
                    this.state.type === "Forgot" && React.createElement(
                        SimpleButton,
                        { className: "modal-message__new-password-btn", onClick: this.onGetPasswordClick.bind(this) },
                        webextApi.i18n.getMessage("NewPassword")
                    ),
                    this.state.type !== "Forgot" && React.createElement(
                        "div",
                        { className: "input-wrapper" },
                        this.state.type === "SignUp" && React.createElement("button", {
                            className: "modal-message__combined",
                            onMouseDown: this.showPassword.bind(this),
                            onMouseUp: this.hidePassword.bind(this)
                        }),
                        React.createElement("input", {
                            onFocus: this.props.closeError,
                            onBlur: this.setInFilledState.bind(this),
                            tabIndex: "2",
                            onKeyDown: this.onKeyPressed,
                            className: this.props.errorStatus ? "modal-message__input modal-message__input_error" : "modal-message__input",
                            id: "modal-message__input_password", type: this.state.isPassShown ? "text" : "password",
                            placeholder: webextApi.i18n.getMessage(this.state.type + "PasswordInput")
                        }),
                        this.state.type === "LogIn" && React.createElement(
                            "div",
                            { className: "modal-message__forgot", onClick: this.changeFormType('Forgot') },
                            webextApi.i18n.getMessage("Forgot")
                        )
                    ),
                    this.state.type === "SignUp" && React.createElement(
                        SimpleButton,
                        { className: "modal-message__login-btn", onClick: this.onSignUpClick.bind(this) },
                        webextApi.i18n.getMessage(this.state.type)
                    ),
                    this.state.type === "LogIn" && React.createElement(
                        "div",
                        { className: "modal-message__login-btn-container" },
                        React.createElement(
                            SimpleButton,
                            { className: "modal-message__login-btn", onClick: this.onLoginClick.bind(this) },
                            webextApi.i18n.getMessage(this.state.type)
                        )
                    )
                )
            ),
            this.state.type !== "Forgot" && React.createElement(
                "div",
                { className: "modal-message__sign-in-container" },
                React.createElement(ModalMessageLogInSocialBtn, { onClick: this.socialLogin('google'), type: "google", text: webextApi.i18n.getMessage(this.state.type + "Google") })
            ),
            this.state.type === 'Forgot' ? React.createElement(
                "div",
                { className: "modal-message__sign-in_i-have-account" },
                React.createElement(
                    "a",
                    { onClick: this.backAfterForgot.bind(this) },
                    webextApi.i18n.getMessage("GoBack")
                )
            ) : React.createElement(
                "div",
                { className: "modal-message__sign-in_i-have-account" },
                webextApi.i18n.getMessage(this.state.type === 'LogIn' ? "IHaveNotAccount" : "IHaveAccount"),
                this.state.type === 'LogIn' ? React.createElement(
                    "a",
                    { onClick: this.changeFormType('SignUp') },
                    webextApi.i18n.getMessage('SignUp')
                ) : React.createElement(
                    "a",
                    { onClick: this.changeFormType('LogIn') },
                    webextApi.i18n.getMessage('LogIn')
                )
            ),
            this.state.type !== "Forgot" && React.createElement(
                "div",
                { className: "modal-message__sign-in_footer" },
                webextApi.i18n.getMessage('bySigningUp'),
                React.createElement(
                    "a",
                    { onClick: this.openTerms.bind(this) },
                    webextApi.i18n.getMessage('terms')
                ),
                webextApi.i18n.getMessage('and'),
                React.createElement(
                    "a",
                    { onClick: this.openPrivacyPolicy.bind(this) },
                    webextApi.i18n.getMessage('privacyPolicy')
                )
            )
        );
    }
}