
class ModalRating extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            rateStore: false
        };
    }
    rateInStore() {
        let url;
        switch (browserName) {
            case 'firefox':
                url = FIREFOX_WEBSTORE_URL;
                break;
            case 'opera':
                url = OPERA_WEBSTORE_URL;
                break;
            case 'chrome':
            default:
                url = CHROME_WEBSTORE_URL;
                break;
        }
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url });
        window.close();
    }
    redirectToExtensionPage(starsCount) {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Main Window",
                [atob("ZWE=")]: "Rate Us Stars",
                [atob("ZWw=")]: starsCount
            }
        });
        let url;
        switch (browserName) {
            case 'firefox':
                url = FIREFOX_WEBSTORE_URL;
                break;
            case 'opera':
                url = OPERA_WEBSTORE_URL;
                break;
            case 'chrome':
            default:
                url = CHROME_WEBSTORE_URL;
                break;
        }
        switch (starsCount) {
            case 5:
                webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url });
                // this.setState({
                //     rateStore:  true
                // });
                this.props.dispatch(mobileTrigerModal());
                window.close();
                break;
            case 4:
                this.props.dispatch(mobileTrigerModal());
            default:
                _.delay(() => {
                    document.getElementById('e' + starsCount).click();
                }, 1000);
                this.props.showModal('feedback')();
                break;
        }
        this.props.dispatch(offRateWidget());
    }
    clickNoThanks() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Main Window",
                [atob("ZWE=")]: "Rate Us No Thanks",
                [atob("ZWw=")]: ""
            }
        });
        this.props.dispatch(offRateWidget());
        this.props.onClose();
    }
    render() {
        return React.createElement(
            'div',
            { className: 'modal-message_rating-flow' },
            React.createElement(
                'div',
                { className: 'rate-us__header' },
                React.createElement(
                    'div',
                    { className: 'close-cross close-cross_bad-rating-notify', onClick: this.props.onClose },
                    React.createElement('span', { className: 'close-cross__hover' }),
                    React.createElement('span', { className: 'close-cross__image' })
                ),
                React.createElement('span', { className: this.state.rateStore ? "rate-us-store__image" : "rate-us__image" })
            ),
            React.createElement(
                'div',
                { className: 'modal-message-container_rating-flow__header' },
                React.createElement(
                    'div',
                    { className: 'modal-message__header modal-message__header_rate-header' },
                    webextApi.i18n.getMessage('wantToRateWOTHeader')
                ),
                React.createElement(
                    'div',
                    { className: 'modal-message__header modal-message__header_rate-text' },
                    webextApi.i18n.getMessage('wantToRateWOT').replace('%BROWSER%', upperFirstCase(browserName))
                )
            ),
            React.createElement(
                'div',
                { className: 'modal-message__button-container modal-message__button-container_column' },
                !this.state.rateStore && React.createElement(StarsContainer, { clickStarAction: this.redirectToExtensionPage.bind(this) }),
                this.state.rateStore && React.createElement(
                    'div',
                    { className: 'modal-message__button-container__item modal-message__button-container__item_rate', onClick: this.rateInStore.bind(this) },
                    React.createElement('i', { className: 'rate-us__button-icon' }),
                    webextApi.i18n.getMessage('wantToRateWOTBtn')
                ),
                React.createElement(
                    'div',
                    { className: 'modal-message__button-container__item modal-message__button-container__item_no-thanks', onClick: this.clickNoThanks.bind(this) },
                    webextApi.i18n.getMessage('noThanks')
                )
            )
        );
    }
}