
class ModalSurvey extends React.Component {
    constructor(props) {
        super(props);
        this.props.store.dispatch(makeSurveyShowed());
        this.startSurvey = this.startSurvey.bind(this);
        this.onClose = this.onClose.bind(this);
    }
    onClose() {
        this.props.onClose();
    }
    startSurvey() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Active user survey",
                [atob("ZWE=")]: "Survey started",
                [atob("ZWw=")]: ""
            }
        });
        const installDate = this.props.store.getState().survey.installDate;
        const qParams = {
            'install date': installDate || null,
            'extension version': getVersion(),
            'browser': browserName,
            'browser version': getBrowserInfo().version,
            'browser language': window.navigator.language,
            'os': getOS()
        };
        const qParamsStr = Object.keys(qParams).map(paramName => {
            const val = qParams[paramName];
            if (!val) return null;
            return [paramName, val].map(encodeURIComponent).join("=");
        }).filter(p => p).join("&");
        webextApi.tabs.create({ url: SURVEY_URL + '?' + qParamsStr.replace(/(\s\r\n|%20)/gm, '_') });
        window.close();
    }
    componentDidMount() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Active user survey",
                [atob("ZWE=")]: "Survey popup displayed",
                [atob("ZWw=")]: ""
            }
        });
    }
    render() {
        return React.createElement(
            "div",
            { className: "modal-survey" },
            React.createElement(
                "div",
                { className: "modal-message__close", onClick: this.onClose },
                React.createElement("span", { className: "modal-message__close-hover" }),
                React.createElement("span", { className: "modal-message__close-image" })
            ),
            React.createElement(
                "div",
                { className: "modal-survey__header" },
                React.createElement("div", { className: "modal-survey__image" })
            ),
            React.createElement(
                "div",
                { className: "modal-survey__text" },
                React.createElement(
                    "span",
                    { className: "modal-message__header modal-message__header_rate-header" },
                    webextApi.i18n.getMessage('surveyHeadline')
                ),
                React.createElement(
                    "span",
                    { className: "modal-message__header modal-message__header_rate-text survey--small-text" },
                    webextApi.i18n.getMessage('surveyAsk')
                )
            ),
            React.createElement(
                "div",
                { className: "modal-survey__start-btn", onClick: this.startSurvey },
                webextApi.i18n.getMessage('startSurvey')
            )
        );
    }
}