var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

class RatingFlowLabels extends React.Component {
    render() {
        var _props = this.props;
        const dispatch = _props.dispatch,
              host = _props.host,
              categories = _props.categories,
              typeCategories = _props.typeCategories,
              step = _props.step,
              clickLabelAction = _props.clickLabelAction,
              textNormal = _props.textNormal,
              userId = _props.userId;

        let classContainer = 'rating-flow',
            lengthInput = 45,
            lengthResult = 38;
        if (typeCategories === 'childSafety') {
            lengthInput = 30;
            lengthResult = 19;
        }
        if (typeCategories === 'safety') {
            lengthInput = 39;
            lengthResult = 29;
        }
        step === 6 && (classContainer += ' rating-flow_right rating-flow_last');
        return React.createElement(
            'div',
            { className: classContainer },
            React.createElement(
                'div',
                { className: 'rating-flow-labels' },
                React.createElement(
                    'div',
                    { className: 'rating-flow_safe__header  rating-flow_safe__header_not-safe' },
                    typeCategories !== 'reputation' && React.createElement('div', { className: 'rating-flow-labels__logo' }),
                    React.createElement(FormattedString, { className: 'rating-flow-labels_not-safe', text: textNormal && textNormal.replace('%DOMAIN%', truncateString(WotApi.getDecodedDomain(host), 12, 7)), maxLength: '45' })
                ),
                React.createElement(
                    Scrollbars,
                    { className: 'warning-reports-container',
                        hideTracksWhenNotNeeded: true,
                        renderView: props => React.createElement('div', _extends({}, props, { className: 'warning-reports-scroll' })),
                        autoHide: false },
                    CATEGORIES_RULES.ratingFlow[typeCategories].map(item => {
                        let classNameReport = 'warning-reports-container__label warning-reports-container__label_rating-flow';
                        if (_.indexOf(categories, +item) !== -1) {
                            classNameReport += ' warning-reports-container__label_' + ALL_CATEGORIES[item].color;
                        }
                        return React.createElement(
                            'div',
                            { className: classNameReport, data: item, onClick: () => {
                                    dispatch(clickLabelAction(host, item, userId));
                                } },
                            webextApi.i18n.getMessage(ALL_CATEGORIES[item].description)
                        );
                    })
                )
            ),
            React.createElement(RatingFlowFooter, { categories: categories, skipOpprtunity: true, typeNextButton: 'active', dispatch: dispatch, host: host, step: step, nextAction: toNextStep, userId: userId })
        );
    }
}