
let store = new Store({
    portName: '4873'
});
function updateUserReviewFromServer(store, tabDomain) {
    const state = store.getState();
    const uid = _.get(state, 'user.uid', null);
    const updateDelay = 60 * 60 * 1000; // 1 hour
    const lastUpdTime = _.get(state.reviews, `${uid}['${tabDomain}'].reviewLastUpdateTimestamp`, 0);;
    const timeSinceLastUpd = new Date().getTime() - lastUpdTime;
    if (timeSinceLastUpd > updateDelay) {
        store.dispatch(getCommentAndRating(tabDomain));
    }
}
store.ready().then(() => {
    webextApi.tabs.query({ active: true, currentWindow: true }, tabs => {
        const curTab = tabs[0];
        curTab && store.dispatch(setActiveTab(curTab.id));
        const currentTab = curTab || _.filter(store.getState().tabs, tab => tab.active)[0];
        if (!currentTab || !SUPPORTED_PROTOCOLS.test(currentTab.url) || checkLocalhost(currentTab.url)) {
            window.close();
        } else {
            const tabDomain = WotApi.getEncodedDomain(currentTab.url);
            updateUserReviewFromServer(store, tabDomain);
            if (!store.state.comments[tabDomain] || store.state.comments[tabDomain].count === 0) {
                updateUserReviewFromServer(store, tabDomain);
                store.dispatch(getComments(tabDomain));
            }
            store.dispatch(checkRateWidgetDate());
            !store.getState().GDPRNotifications && store.dispatch(countPopupOpening());
            !!store.state.user.token && store.dispatch(saveToken());
            injectFonts();
            /*window.addEventListener('message', (event)=>{
                console.log(event);
                if(event && event.data && event.data.status === 'login') {
                    store.dispatch(saveToken(event.data.token));
                } else if (event && event.data && event.data.status !== 'login') {
                }
                console.info(event);
            });*/
            window.onwheel = e => {
                let a = 0,
                    parentExceed = false,
                    scroll = document.querySelector('.rating-flow-scroll'),
                    delta = 100;
                if (e.deltaY < 0) {
                    delta = -1 * delta;
                }
                if (scroll) {
                    if (e.path) {
                        for (let target of e.path) {
                            if (target.className && target.className.indexOf('rating-flow-scroll') !== -1) {
                                parentExceed = true;
                            }
                        }
                    }
                    while (a < 300 && !parentExceed) {
                        _.delay(() => {
                            scroll.scrollBy ? scroll.scrollBy(0, delta / 100) : scroll.contentWindow && scroll.contentWindow.scrollBy(0, delta / 100);
                        }, a);
                        a += 3;
                    }
                }
            };
            ReactDOM.render(React.createElement(
                ReactRedux.Provider,
                { store: store },
                React.createElement(MainComponent, { store: store })
            ), document.getElementById('appcontainer'));
        }
    });
});